#include "E.h"

void DrawEwinShape(EWin *ewin, int mode, int x, int y, int w, int h, char firstlast)
{
   GC gc;
   XGCValues gcv;
   int x1,y1,w1,h1;
   
/*   if (firstlast==0) XGrabServer(disp);*/
   switch (mode)
     {
      case 0:
	MoveResizeEwin(ewin,x,y,w,h);
	break;
      case 1:
	x1=ewin->x;y1=ewin->y;w1=ewin->client.w;h1=ewin->client.h;
	ewin->x=x;ewin->y=y;ewin->client.w=w;ewin->client.h=h;
	ICCCM_MatchSize(ewin);
	ewin->w=ewin->client.w+ewin->border->border.left+ewin->border->border.right; 
	ewin->h=ewin->client.h+ewin->border->border.top+ewin->border->border.bottom; 
	x=ewin->x;y=ewin->y;w=ewin->client.w;h=ewin->client.h;
	gcv.function=GXxor;gcv.foreground=WhitePixel(disp,root.scr);
	gcv.subwindow_mode=IncludeInferiors;
	gc=XCreateGC(disp,root.win,GCFunction|GCForeground|GCSubwindowMode,&gcv);
	if (firstlast>0)
	  {
	     XDrawLine(disp,root.win,gc,x1,0,x1,root.h);
	     XDrawLine(disp,root.win,gc,
		       x1+w1+ewin->border->border.left+
		       ewin->border->border.right-1,0,
		       x1+w1+ewin->border->border.left+
		       ewin->border->border.right-1,root.h);
	     XDrawLine(disp,root.win,gc,0,y1,root.w,y1);
	     XDrawLine(disp,root.win,gc,0,
		       y1+h1+ewin->border->border.top+
		       ewin->border->border.bottom-1,root.w,
		       y1+h1+ewin->border->border.top+
		       ewin->border->border.bottom-1);
	     XDrawRectangle(disp,root.win,gc,x1+ewin->border->border.left,
			    y1+ewin->border->border.top,w1-1,h1-1);
	  }
	if (firstlast<2)
	  {
	     XDrawLine(disp,root.win,gc,x,0,x,root.h);
	     XDrawLine(disp,root.win,gc,
		       x+w+ewin->border->border.left+
		       ewin->border->border.right-1,0,
		       x+w+ewin->border->border.left+
		       ewin->border->border.right-1,root.h);
	     XDrawLine(disp,root.win,gc,0,y,root.w,y);
	     XDrawLine(disp,root.win,gc,0,
		       y+h+ewin->border->border.top+
		       ewin->border->border.bottom-1,root.w,
		       y+h+ewin->border->border.top+
		       ewin->border->border.bottom-1);
	     XDrawRectangle(disp,root.win,gc,x+ewin->border->border.left,
			    y+ewin->border->border.top,w-1,h-1);
	  }
	if (firstlast==2) MoveResizeEwin(ewin,x,y,w,h);
	XFreeGC(disp,gc);
	break;
      default:
	break;
     }
/*   if (firstlast==2) XUngrabServer(disp);*/
}

ImlibImage *ELoadImage(char *file)
{
   return Imlib_load_image(id,file);
}

void PropagateShapes(Window win)
{
   Window rt,par,*list=NULL;
   int k,i,j,num=0,num_rects=0,rn=0,ord;
   int x,y,w,h,d;
   XRectangle *rects=NULL,*rl=NULL;
   
   XQueryTree(disp,win,&rt,&par,&list,&num);
   if (list)
     {
	for(i=0;i<num;i++)
	  {
	     XGetGeometry(disp,list[i],&rt,&x,&y,&w,&h,&d,&d);
	     rl=XShapeGetRectangles(disp,list[i],ShapeBounding,&rn,&ord);
	     if (rl)
	       {
		  num_rects+=rn;
		  rects=realloc(rects,num_rects*sizeof(XRectangle));
		  for(k=0,j=num_rects-rn;j<num_rects;j++,k++)
		    {
		       rects[j].x=rl[k].x+x;
		       rects[j].y=rl[k].y+y;
		       rects[j].width=rl[k].width;
		       rects[j].height=rl[k].height;
		    }
		  XFree(rl);
	       }
	  }
	if (rects)
	  {
	     XShapeCombineRectangles(disp,win,ShapeBounding,0,0,rects,num_rects,
				     ShapeSet,Unsorted);
	     free(rects);
	  }
	XFree(list);
     }
}
