#include "E.h"

void GrabActionKey(Action *a) 
{
   int mod;
   
   if (!a->key) return;
   mod=a->modifiers;
   if (a->anymodifier) mod=AnyModifier;
   XGrabKey(disp,a->key,mod,root.win,False,GrabModeAsync,GrabModeAsync);
}

void UnGrabActionKey(Action *a) 
{
   int mod;
   
   if (!a->key) return;
   mod=a->modifiers;
   if (a->anymodifier) mod=AnyModifier;
   XUngrabKey(disp,a->key,mod,root.win);
}

void GrabTheButtons(Window win) 
{
   if (mode.click_focus_grabbed) return;
   XGrabPointer(disp,win,True,ButtonPressMask|ButtonReleaseMask,GrabModeAsync,
		GrabModeAsync,None,None,CurrentTime);
   grab_window=win;
   mode.click_focus_grabbed=1;
}

void UnGrabTheButtons() 
{
   if (!mode.click_focus_grabbed) return;
   XUngrabPointer(disp,CurrentTime);
   mode.click_focus_grabbed=0;
   grab_window=0;
}
