#include "E.h"

void FocusToEWin(EWin *ewin)
{
   if (mode.focuswin) 
     {
	mode.focuswin->active=0;
	mode.focuswin->state&=~EWIN_ACTIVE;
	DrawEwin(mode.focuswin);
     }
   mode.focuswin=ewin;
   if (mode.focuswin) 
     {
	mode.focuswin->active=1;
	mode.focuswin->state|=EWIN_ACTIVE;
	DrawEwin(mode.focuswin);
     }
   ICCCM_Focus(mode.focuswin);
}

EWin *FindEwinByBase(Window win)
{
   EWin *ewin;
   List *ptr;
   
   ptr=lists.next;
   while(ptr)
     {
	if (ptr->type==LIST_TYPE_EWIN)
	  {
	     ewin=(EWin *)ptr->item;
	     if (win==ewin->win)
	       return ewin;
	  }
	ptr=ptr->next;
     }
   return NULL;
}

EWin *FindEwinByChildren(Window win)
{
   EWin *ewin;
   List *ptr;
   int i;
   
   ptr=lists.next;
   while(ptr)
     {
	if (ptr->type==LIST_TYPE_EWIN)
	  {
	     ewin=(EWin *)ptr->item;
	     if (win==ewin->client.win)
	       return ewin;
	     else
	       {
		  for(i=0;i<ewin->border->num_winparts;i++)
		    if (win==ewin->bits[i].win)
		      return ewin;
	       }
	  }
	ptr=ptr->next;
     }
   return NULL;
}

EWin *FindEwinByDecoration(Window win)
{
   EWin *ewin;
   List *ptr;
   int i;
   
   ptr=lists.next;
   while(ptr)
     {
	if (ptr->type==LIST_TYPE_EWIN)
	  {
	     ewin=(EWin *)ptr->item;
	     for(i=0;i<ewin->border->num_winparts;i++)
	       if (win==ewin->bits[i].win)
		 return ewin;
	  }
	ptr=ptr->next;
     }
   return NULL;
}
