#include "E.h"

int main(int argc, char **argv)
{
   Border *b;
   ImageClass *ic;
   ImlibColor icl;
   TextClass *tc;
   ActionClass *ac;
   Action *a;
   
   SetupSignals();
   SetupX();
   XGrabServer(disp);
   MapUnmap(0);
   SetupDirs();
   CommsSetup();
   CommsFindCommsWindow();

   ac=CreateAclass("GLOBAL_ACTION_EXIT");
   AddItem(ac,ac->name,0,LIST_TYPE_ACLASS_GLOBAL);
   a=CreateAction(EVENT_KEY_UP,0,ControlMask,0,0,0,"Escape");
   AddAction(ac,a);
   AddToAction(a,ACTION_EXIT,NULL);

   ac=CreateAclass("GLOBAL_ACTION_HELP");
   AddItem(ac,ac->name,0,LIST_TYPE_ACLASS_GLOBAL);
   a=CreateAction(EVENT_KEY_UP,1,0,0,0,0,"Pause");
   GrabActionKey(a);
   AddAction(ac,a);
   AddToAction(a,ACTION_ALERT,"Help Help!\nI'm drowning\n");

   ac=CreateAclass("GLOBAL_ACTION_CLEANUP_BYSIZE");
   AddItem(ac,ac->name,0,LIST_TYPE_ACLASS_GLOBAL);
   a=CreateAction(EVENT_KEY_UP,0,0,0,0,0,"F12");
   GrabActionKey(a);
   AddAction(ac,a);
   AddToAction(a,ACTION_CLEANUP,"size");

   ac=CreateAclass("GLOBAL_ACTION_CLEANUP_BYPLACE");
   AddItem(ac,ac->name,0,LIST_TYPE_ACLASS_GLOBAL);
   a=CreateAction(EVENT_KEY_UP,0,ShiftMask,0,0,0,"F12");
   GrabActionKey(a);
   AddAction(ac,a);
   AddToAction(a,ACTION_CLEANUP,"place");

   ac=CreateAclass("GLOBAL_ACTION_DESKNAV");
   AddItem(ac,ac->name,0,LIST_TYPE_ACLASS_GLOBAL);
   a=CreateAction(EVENT_KEY_DOWN,0,ShiftMask,0,0,0,"Right");
   GrabActionKey(a);
   AddAction(ac,a);
   AddToAction(a,ACTION_DESKTOP_NEXT,NULL);
   a=CreateAction(EVENT_KEY_DOWN,0,ShiftMask,0,0,0,"Left");
   GrabActionKey(a);
   AddAction(ac,a);
   AddToAction(a,ACTION_DESKTOP_PREV,NULL);

   ac=CreateAclass("GLOBAL_ACTION_CLEANUP_BYORDER");
   AddItem(ac,ac->name,0,LIST_TYPE_ACLASS_GLOBAL);
   a=CreateAction(EVENT_KEY_UP,0,ControlMask,0,0,0,"F12");
   GrabActionKey(a);
   AddAction(ac,a);
   AddToAction(a,ACTION_CLEANUP,"order");
   
   ac=CreateAclass("ACTION_MOVE");
   AddItem(ac,ac->name,0,LIST_TYPE_ACLASS);
   a=CreateAction(EVENT_MOUSE_DOWN,1,0,1,0,0,NULL);
   AddAction(ac,a);
   AddToAction(a,ACTION_RAISE,NULL);
   AddToAction(a,ACTION_MOVE,NULL);

   ac=CreateAclass("ACTION_RESIZE");
   AddItem(ac,ac->name,0,LIST_TYPE_ACLASS);
   a=CreateAction(EVENT_MOUSE_DOWN,1,0,1,0,0,NULL);
   AddAction(ac,a);
   AddToAction(a,ACTION_RAISE,NULL);
   AddToAction(a,ACTION_RESIZE,NULL);

   ac=CreateAclass("ACTION_RESIZE_H");
   AddItem(ac,ac->name,0,LIST_TYPE_ACLASS);
   a=CreateAction(EVENT_MOUSE_DOWN,1,0,1,0,0,NULL);
   AddAction(ac,a);
   AddToAction(a,ACTION_RAISE,NULL);
   AddToAction(a,ACTION_RESIZE_H,NULL);

   ac=CreateAclass("ACTION_RESIZE_V");
   AddItem(ac,ac->name,0,LIST_TYPE_ACLASS);
   a=CreateAction(EVENT_MOUSE_DOWN,1,0,1,0,0,NULL);
   AddAction(ac,a);
   AddToAction(a,ACTION_RAISE,NULL);
   AddToAction(a,ACTION_RESIZE_V,NULL);
   
   ac=CreateAclass("ACTION_KILL");
   AddItem(ac,ac->name,0,LIST_TYPE_ACLASS);
   a=CreateAction(EVENT_MOUSE_DOWN,1,0,0,1,0,NULL);
   AddAction(ac,a);
   AddToAction(a,ACTION_KILL,NULL);
   a=CreateAction(EVENT_MOUSE_DOWN,1,0,0,3,0,NULL);
   AddAction(ac,a);
   AddToAction(a,ACTION_KILL_NASTY,NULL);

   b=CreateBorder("DEFAULT");
   b->border.left=5;
   b->border.right=5;
   b->border.top=25;
   b->border.bottom=5;
   AddItem(b,b->name,0,LIST_TYPE_BORDER);

   tc=CreateTclass();
   tc->name=strdup("TEXT1");
   tc->norm.normal=CreateTextState();
   tc->norm.normal->fontname=strdup("shinymetal");
   tc->norm.normal->style.mode=MODE_VERBATIM;
   TclassPopulate(tc);
   AddItem(tc,tc->name,0,LIST_TYPE_TCLASS);
   
   ic=CreateIclass();
   ic->name=strdup("CLASS1");
   ic->norm.normal=CreateImageState();
   ic->norm.normal->im_file=strdup("Epanelb1.png");
   ic->norm.normal->border=Emalloc(sizeof(ImlibBorder));
   ic->norm.clicked=CreateImageState();
   ic->norm.clicked->im_file=strdup("Epanelb3.png");
   ic->norm.clicked->border=Emalloc(sizeof(ImlibBorder));
   ic->norm.hilited=CreateImageState();
   ic->norm.hilited->im_file=strdup("Epanelb2.png");
   ic->norm.hilited->border=Emalloc(sizeof(ImlibBorder));
   ic->norm.normal->border->left=25;
   ic->norm.normal->border->right=8;
   ic->norm.normal->border->top=3;
   ic->norm.normal->border->bottom=5;
   ic->norm.clicked->border->left=25;
   ic->norm.clicked->border->right=8;
   ic->norm.clicked->border->top=3;
   ic->norm.clicked->border->bottom=5;
   ic->norm.hilited->border->left=25;
   ic->norm.hilited->border->right=8;
   ic->norm.hilited->border->top=3;
   ic->norm.hilited->border->bottom=5;
   ic->active.normal=CreateImageState();
   ic->active.normal->im_file=strdup("Epanel1.png");
   ic->active.normal->border=Emalloc(sizeof(ImlibBorder));
   ic->active.clicked=CreateImageState();
   ic->active.clicked->im_file=strdup("Epanel3.png");
   ic->active.clicked->border=Emalloc(sizeof(ImlibBorder));
   ic->active.hilited=CreateImageState();
   ic->active.hilited->im_file=strdup("Epanel2.png");
   ic->active.hilited->border=Emalloc(sizeof(ImlibBorder));
   ic->active.normal->border->left=25;
   ic->active.normal->border->right=8;
   ic->active.normal->border->top=3;
   ic->active.normal->border->bottom=5;
   ic->active.clicked->border->left=25;
   ic->active.clicked->border->right=8;
   ic->active.clicked->border->top=3;
   ic->active.clicked->border->bottom=5;
   ic->active.hilited->border->left=25;
   ic->active.hilited->border->right=8;
   ic->active.hilited->border->top=3;
   ic->active.hilited->border->bottom=5;
   ic->padding.left=25;
   ic->padding.right=8;
   ic->padding.top=3;
   ic->padding.bottom=5;
   IclassPopulate(ic);
   AddItem(ic,ic->name,0,LIST_TYPE_ICLASS);
   ic=CreateIclass();
   ic->name=strdup("CLASS2");
   ic->norm.normal=CreateImageState();
   ic->norm.clicked=CreateImageState();
   ic->norm.hilited=CreateImageState();
   ic->norm.normal->bevelstyle=BEVEL_DOUBLE;
   ic->norm.clicked->bevelstyle=BEVEL_WIDEDOUBLE;
   ic->norm.hilited->bevelstyle=BEVEL_NEXT;
   IclassPopulate(ic);
   AddItem(ic,ic->name,0,LIST_TYPE_ICLASS);
   
   ac=FindItem("ACTION_MOVE",0,LIST_FINDBY_NAME,LIST_TYPE_ACLASS);
   ic=FindItem("CLASS1",0,LIST_FINDBY_NAME,LIST_TYPE_ICLASS);
   tc=FindItem("TEXT1",0,LIST_FINDBY_NAME,LIST_TYPE_TCLASS);
   AddBorderPart(b,ic,ac,tc,1,FLAG_TITLE,0,0,9999,0,9999,-1,0,0,0,0,-1,1023,-20,0,26);
   ic=FindItem("CLASS2",0,LIST_FINDBY_NAME,LIST_TYPE_ICLASS);
   ac=FindItem("ACTION_KILL",0,LIST_FINDBY_NAME,LIST_TYPE_ACLASS);
   AddBorderPart(b,ic,ac,tc,0,FLAG_MINIICON,0,0,9999,0,9999,0,1024,0,0,0,-1,1023,0,0,24);
   ic=FindItem("CLASS1",0,LIST_FINDBY_NAME,LIST_TYPE_ICLASS);
   ac=FindItem("ACTION_RESIZE_H",0,LIST_FINDBY_NAME,LIST_TYPE_ACLASS);
   AddBorderPart(b,ic,ac,tc,0,FLAG_BUTTON,0,0,9999,0,9999,1,0,0,1024,0,-1,1023,0,1023,-5);
   ac=FindItem("ACTION_RESIZE",0,LIST_FINDBY_NAME,LIST_TYPE_ACLASS);
   AddBorderPart(b,ic,ac,tc,0,FLAG_BUTTON,0,0,9999,0,9999,-1,0,0,1023,-4,-1,512,-10,1023,0);
   ac=FindItem("ACTION_RESIZE_V",0,LIST_FINDBY_NAME,LIST_TYPE_ACLASS);
   AddBorderPart(b,ic,ac,tc,0,FLAG_BUTTON,0,20,20,0,9999,3,1024,0,0,0,3,1024,19,1023,0);
   ac=FindItem("ACTION_RESIZE",0,LIST_FINDBY_NAME,LIST_TYPE_ACLASS);
   AddBorderPart(b,ic,ac,tc,0,FLAG_BUTTON,0,0,9999,0,9999,4,1024,0,0,0,-1,1023,0,1023,0);

   icl.r=10;icl.g=20;icl.b=100;
   SetDesktopBg(0,&icl,"bg.png",1,0,512,512,0,0,"Elogo.png",1,512,512,0,0);
   icl.r=80;icl.g=20;icl.b=10;
   SetDesktopBg(1,&icl,"bg.png",1,0,512,512,0,0,"Enlightenment.png",1,0,1023,0,0);
   icl.r=40;icl.g=20;icl.b=40;
   SetDesktopBg(2,&icl,"bg.png",1,0,512,512,0,0,NULL,0,0,0,0,0);
   SetDesktopBg(3,NULL,"bg1.ppm",1,0,512,512,1024,1024,NULL,0,0,0,0,0);
   SetDesktopBg(4,NULL,"bg2.ppm",1,0,0,0,0,0,NULL,0,0,0,0,0);
   SetDesktopBg(5,NULL,"bg3.ppm",0,0,512,512,0,0,NULL,0,0,0,0,0);
   SetDesktopBg(6,NULL,"bg4.ppm",0,0,512,512,0,0,"pengee2.png",1,512,512,0,0);
   SetDesktopBg(7,NULL,"bg5.ppm",0,0,512,512,1024,1024,"pengee2.png",1,512,512,0,0);
   SetDesktopBg(8,NULL,"bg6.ppm",0,0,512,512,1024,1024,NULL,0,0,0,0,0);
   icl.r=255;icl.g=255;icl.b=255;
   SetDesktopBg(17,&icl,NULL,0,0,512,512,1024,1024,"pengee.ppm",1,512,512,0,0);
   
   XUngrabServer(disp);
   CheckEvent();
   MapUnmap(1);
   for(;;) 
     {
	WaitEvent();
     }
}
