#include "E.h"

Window ECreateWindow(Window parent, int x, int y, int w, int h, int saveunder)
{
   Window win;
   XSetWindowAttributes attr;
   
   attr.backing_store=NotUseful;
   attr.override_redirect=False;
   attr.colormap=root.cmap;
   attr.border_pixel=0;
   attr.background_pixel=0;
   if (saveunder) attr.save_under=True;
   else attr.save_under=False;
   win=XCreateWindow(disp,parent,x,y,w,h,0,root.depth,InputOutput,root.vis,
		     CWOverrideRedirect|CWSaveUnder|CWBackingStore|CWColormap|
		     CWBackPixel|CWBorderPixel,&attr);
   XSetWindowBackground(disp,win,0);
   return win;
}

Window ECreateEventWindow(Window parent, int x, int y, int w, int h)
{
   Window win;
   XSetWindowAttributes attr;
   
   attr.backing_store=NotUseful;
   attr.override_redirect=False;
   attr.colormap=root.cmap;
   attr.border_pixel=0;
   attr.background_pixel=0;
   attr.save_under=False;
   win=XCreateWindow(disp,parent,x,y,w,h,0,root.depth,InputOnly,root.vis,
		     CWOverrideRedirect|CWSaveUnder|CWBackingStore|CWColormap|
		     CWBackPixel|CWBorderPixel,&attr);
   XSetWindowBackground(disp,win,0);
   return win;
}
